###################################################
### chunk number 1:  eval=FALSE
###################################################
## #line 173 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
## install.package("rsae")


###################################################
### chunk number 2: 
###################################################
#line 182 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
library(rsae)


###################################################
### chunk number 3: 
###################################################
#line 205 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
data(landsat)


###################################################
### chunk number 4: 
###################################################
#line 210 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
names(landsat)


###################################################
### chunk number 5: 
###################################################
#line 215 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
table(landsat$CountyName)


###################################################
### chunk number 6: 
###################################################
#line 223 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
landsat[30:35, c("HACorn", "PixelsCorn", "PixelsSoybeans", "CountyName", "outlier")]


###################################################
### chunk number 7: 
###################################################
#line 229 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
   linmodel <- lm(HACorn ~ PixelsCorn + PixelsSoybeans, data = landsat)
   plot(linmodel, 5)


###################################################
### chunk number 8:  eval=FALSE
###################################################
## #line 237 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
##    linmodel <- lm(HACorn ~ PixelsCorn + PixelsSoybeans, data = landsat)
##    plot(linmodel, 5)


###################################################
### chunk number 9: 
###################################################
#line 258 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
bhfmodel <- saemodel(formula=HACorn ~ PixelsCorn + PixelsSoybeans, 
                    area=~CountyName, 
                    data=subset(landsat, subset=(outlier==FALSE)))


###################################################
### chunk number 10: 
###################################################
#line 268 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
bhfmodel


###################################################
### chunk number 11: 
###################################################
#line 274 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
summary(bhfmodel)


###################################################
### chunk number 12: 
###################################################
#line 295 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
mlfit <- fitsaemodel("ml", bhfmodel)


###################################################
### chunk number 13: 
###################################################
#line 300 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
mlfit


###################################################
### chunk number 14: 
###################################################
#line 310 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
summary(mlfit)


###################################################
### chunk number 15: 
###################################################
#line 320 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
failconvg <- fitsaemodel("ml", bhfmodel, niter=1)


###################################################
### chunk number 16: 
###################################################
#line 326 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
failconvg


###################################################
### chunk number 17: 
###################################################
#line 332 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
convergence(failconvg)


###################################################
### chunk number 18: 
###################################################
#line 348 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
set.seed(12345)
n <- 200; beta <- c(1, 1)
cst <- rep(1, n)
x <- rnorm(n)
y <- as.matrix(cbind(cst, x)) %*% beta + rnorm(n)
areaid <- rep(1:10, each=10)
df <- data.frame(y=y, x=x, areaid=areaid)


###################################################
### chunk number 19: 
###################################################
#line 359 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
lm(y ~ x, data=df)


###################################################
### chunk number 20: 
###################################################
#line 364 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
fakemlm <- saemodel(y ~ x, area=~areaid, data=df)


###################################################
### chunk number 21: 
###################################################
#line 370 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
fitsaemodel("ml", fakemlm)


###################################################
### chunk number 22: 
###################################################
#line 391 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
huberfit <- fitsaemodel("huberm", bhfmodel, k=1.5)


###################################################
### chunk number 23: 
###################################################
#line 399 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
huberfit


###################################################
### chunk number 24: 
###################################################
#line 405 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
summary(huberfit)


###################################################
### chunk number 25: 
###################################################
#line 420 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
convergence(huberfit)


###################################################
### chunk number 26: 
###################################################
#line 458 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
fitsaemodel("huberm", bhfmodel, k=1.2, init="s")


###################################################
### chunk number 27: 
###################################################
#line 490 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
d <- unique(landsat[-33, c("MeanPixelsCorn", "MeanPixelsSoybeans", "CountyName")])
d <- cbind(rep(1,12), d)
rownames(d) <- d$CountyName
d <- d[,1:3]


###################################################
### chunk number 28: 
###################################################
#line 498 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
d


###################################################
### chunk number 29: 
###################################################
#line 506 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
pr <- robpredict(mlfit, areameans=d, reps=500)


###################################################
### chunk number 30: 
###################################################
#line 511 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
pr 


###################################################
### chunk number 31: 
###################################################
#line 517 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
plot(pr)


###################################################
### chunk number 32: 
###################################################
#line 523 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
plot(pr, type="l", sort="means")


###################################################
### chunk number 33: 
###################################################
#line 538 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
res <- residuals(pr)
qqnorm(res)
qqline(res)


###################################################
### chunk number 34: 
###################################################
#line 593 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
mymodel <- makedata()


###################################################
### chunk number 35: 
###################################################
#line 601 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
mymodel


###################################################
### chunk number 36: 
###################################################
#line 607 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
summary(mymodel)


###################################################
### chunk number 37: 
###################################################
#line 616 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
makedata(ve.epsilon=0.1)


###################################################
### chunk number 38: 
###################################################
#line 622 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
makedata(vu.epsilon=0.1)


###################################################
### chunk number 39: 
###################################################
#line 628 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
makedata(vu.epsilon=0.1, ve.epsilon=0.1)


###################################################
### chunk number 40: 
###################################################
#line 639 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
my_area_id = c(1,1,1,1,1,2,2,3,3,3,4,4,4,4,4,5)


###################################################
### chunk number 41: 
###################################################
#line 647 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
mymodelub <- makedata(n=NULL, g=NULL, areaID=my_area_id)


###################################################
### chunk number 42: 
###################################################
#line 659 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
citation("rsae")


###################################################
### chunk number 43: 
###################################################
#line 668 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
fitsaemodel("ml", bhfmodel)


###################################################
### chunk number 44: 
###################################################
#line 674 "d:/Rcompile/CRANpkg/local/2.12/rsae/inst/doc/rsae.Rnw"
require(nlme)
nlme::lme(HACorn ~ PixelsCorn + PixelsSoybeans, random=~1|CountyName, data=subset(landsat, subset=(outlier==FALSE)), method="ML")


